<?php
namespace Teknisa\GQL\Modules\Cadastros\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response\Notification;
use Teknisa\GQL\Modules\Cadastros\Services\gql00600ToleranciaDasNaoConformidadesService;

class gql00600ToleranciaDasNaoConformidadesController
{
    protected $connection;
    
    public function __construct (gql00600ToleranciaDasNaoConformidadesService $service, $connection)
    {
        $this->service       = $service;
        $this->connection    = $connection;
    }
    
    public function insertTolerancia(DTO\Request\Row $request, DTO\Response $response)
    {
        try {
            $row = $request->getRow();
            
            self::verifyTolerancia($row, $response);
            
            $this->service->insertTolerancia($row);
            
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    public function updateTolerancia(DTO\Request\Row $request, DTO\Response $response)
    {
        try {
            $row = $request->getRow();
            
            $this->service->updateTolerancia($row);
            
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    public function deleteTolerancia(DTO\Request\Row $request, DTO\Response $response)
    {
        try {
            $row = $request->getRow();
            
            $this->service->deleteTolerancia($row);
            
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
    
    public function verifyTolerancia($row, $response)
    {
        if ($this->service->getTolerancia($row)[0]['RETORNO'] > 0) {
            throw new \Exception("Tolerância já cadastrada.");
        }
    }
}